<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAllCommitmentsInput StructType
 * @subpackage Structs
 */
class GetAllCommitmentsInput extends AbstractStructBase
{
    /**
     * The SubDealerId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $SubDealerId;
    /**
     * The CreateDateRangeStart
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $CreateDateRangeStart;
    /**
     * The CreateDateRangeEnd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $CreateDateRangeEnd;
    /**
     * Constructor method for GetAllCommitmentsInput
     * @uses GetAllCommitmentsInput::setSubDealerId()
     * @uses GetAllCommitmentsInput::setCreateDateRangeStart()
     * @uses GetAllCommitmentsInput::setCreateDateRangeEnd()
     * @param int $subDealerId
     * @param string $createDateRangeStart
     * @param string $createDateRangeEnd
     */
    public function __construct($subDealerId = null, $createDateRangeStart = null, $createDateRangeEnd = null)
    {
        $this
            ->setSubDealerId($subDealerId)
            ->setCreateDateRangeStart($createDateRangeStart)
            ->setCreateDateRangeEnd($createDateRangeEnd);
    }
    /**
     * Get SubDealerId value
     * @return int
     */
    public function getSubDealerId()
    {
        return $this->SubDealerId;
    }
    /**
     * Set SubDealerId value
     * @param int $subDealerId
     * @return \CustomerManagement\StructType\GetAllCommitmentsInput
     */
    public function setSubDealerId($subDealerId = null)
    {
        // validation for constraint: int
        if (!is_null($subDealerId) && !(is_int($subDealerId) || ctype_digit($subDealerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($subDealerId, true), gettype($subDealerId)), __LINE__);
        }
        $this->SubDealerId = $subDealerId;
        return $this;
    }
    /**
     * Get CreateDateRangeStart value
     * @return string
     */
    public function getCreateDateRangeStart()
    {
        return $this->CreateDateRangeStart;
    }
    /**
     * Set CreateDateRangeStart value
     * @param string $createDateRangeStart
     * @return \CustomerManagement\StructType\GetAllCommitmentsInput
     */
    public function setCreateDateRangeStart($createDateRangeStart = null)
    {
        // validation for constraint: string
        if (!is_null($createDateRangeStart) && !is_string($createDateRangeStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createDateRangeStart, true), gettype($createDateRangeStart)), __LINE__);
        }
        $this->CreateDateRangeStart = $createDateRangeStart;
        return $this;
    }
    /**
     * Get CreateDateRangeEnd value
     * @return string
     */
    public function getCreateDateRangeEnd()
    {
        return $this->CreateDateRangeEnd;
    }
    /**
     * Set CreateDateRangeEnd value
     * @param string $createDateRangeEnd
     * @return \CustomerManagement\StructType\GetAllCommitmentsInput
     */
    public function setCreateDateRangeEnd($createDateRangeEnd = null)
    {
        // validation for constraint: string
        if (!is_null($createDateRangeEnd) && !is_string($createDateRangeEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createDateRangeEnd, true), gettype($createDateRangeEnd)), __LINE__);
        }
        $this->CreateDateRangeEnd = $createDateRangeEnd;
        return $this;
    }
}
